Subject: bug#69431: 30.0.50; Strange fontificaion behavior

From: Stefan Monnier <[email-masked]>
Date: Wed, 27 Mar 2024 10:27:00 -0400

>>> I'm trying to progress on this but I've difficult time at getting a grip
>>> on this bug.  One of the reason why is that on my reproducer Emacs
>>> doesn't crash nor complain, the other reason is that I'm not really into
>>> our fontification.  I'll keep on looking into it but I'd appretiate any
>>> hint like: what should be happening to fontify the buffer that is not
>>> actually happening here?  With such info I could try investingating the
>>> issue from there comparing with the working case.
>>
>> Hmm... here, after
>>
>>     rm -rf ~/.emacs.d/eln-cache
>>     src/emacs -Q --eval '(setq debug-on-error t)' a.org
>>
>> I get a buffer with no fontification, that claims to be in Org mode but
>> whose `font-lock-keywords` is just (t nil), which explains the lack
>> of fontification.
>
> Where `font-lock-keywords` are supposed to be set?

`font-lock-keywords` is normally set from `font-lock-defaults` (which is
set by the major-mode) by `font-lock-set-defaults` when `font-lock-mode`
is enabled (which usually happens soon after enabling the major mode,
via `after-change-major-mode-hook`).

        Stefan